function wp_pano_3d(width,height,path,imgtype,parts,layers,part_len,len,pos,layer,loop) {
	var Path=path,Pos=pos,Loop=loop,Parts=parts,Layers=layers,PartLen=part_len,Len=len,Pos=pos,Layer=layer;
	var over_last,down_last,link_last;
	var state=false;
	var canvas = document.createElement('canvas');
	canvas.width=width;
	canvas.height=height;
	canvas.id="id_canvas_"+Path;
	var context=canvas.getContext("2d");
	var X=0,Y=0;
	var images=parts*layers;
	var Img=new Array(images);
	for (j=k=0;j<layers;j++) {
		for (i=0;i<parts;i++) { Img[k]=new Image(); Img[k].src=path+"/img_"+(1*j+1)+"_"+(1*i+1)+imgtype; k++; }
	}
	
	canvas.onmousemove=function(e) { X=e.offsetX; Y=e.offsetY; };
	canvas.onmousedown=function(e) { state=true; };
	canvas.onmouseup=function(e) { state=false;	};
	canvas.onmouseover=function(e) { state=false; };
	canvas.onmouseout=function(e) { state=false; };

	canvas.addEventListener('touchmove', function(event) { 
		event.preventDefault();
		if (!state) return;
		var touch = event.changedTouches[0]; 
		X=touch.pageX-canvas.offsetLeft; Y=touch.pageY-canvas.offsetTop; 
	}, false);

	canvas.addEventListener('touchstart', function(event) { 
		event.preventDefault();
		var touch = event.changedTouches[0];
		X=touch.pageX-canvas.offsetLeft; Y=touch.pageY-canvas.offsetTop; 
		state=true;
	}, false);

	canvas.addEventListener('touchend', function(event) { event.preventDefault(); state=false; }, false);

	canvas.addEventListener('touchcancel', function(event) { state=false; }, false);

	canvas.check=function() {
		var x,y,dx,sm=0,area,n,m,k;
		var rect=canvas.getBoundingClientRect();
		var index=0;
		area=Math.floor(7*X/rect.width);
		dx=rect.width/7;
		if (area==3) sm=0;
		else if (area==0) sm=-Math.round((dx-X)*2+1.5*dx);
		else if (area==1) sm=-Math.round((2*dx-X)+0.5*dx);
		else if (area==2) sm=-Math.round((3*dx-X)/2);
		else if (area==4) sm=Math.round((X-4*dx)/2);
		else if (area==5) sm=Math.round((X-5*dx)+0.5*dx);
		else if (area==6) sm=Math.round((X-6*dx)*2+1.5*dx);
		sm=Math.round(sm/5);
		if (!state) sm=0;
		pano=Math.floor(Layers*Y/rect.height);
		k=pano*Parts;
		if (Loop) {
			Pos=1*Pos+1*sm;
			if (1*Pos>=len) Pos=Pos-len;
			if (1*Pos<0) Pos=1*Pos+len;
			n=Math.floor(Pos/PartLen);
			m=Pos-n*PartLen;
		}
		else { 
			Pos=1*Pos+1*sm;
			if (Pos+rect.width>=len) Pos=len-rect.width;
			if (1*Pos<0) Pos=0;
			n=Math.floor(Pos/PartLen);
			m=Pos-n*PartLen;
		}
		if (Img[n+k].complete) context.drawImage(Img[n+k],-m,0); 
		if (Img[n+k].width-m<rect.width) { 
			nn=n+1; 
			if (nn>=images) nn=0; 
			if (Img[nn+k].complete) context.drawImage(Img[nn+k],Img[n+k].width-m,0); 
		}
	};
	
	document.writeln("<div id='id_div_"+Path+"'></div>");
	document.getElementById("id_div_"+Path).insertBefore(canvas,null);
	setInterval('document.getElementById("id_canvas_'+Path+'").check()',30);

}

function wp_table_pano_3d(width,height,pano_height,path,imgtype,layers) {
	var Path=path,Layers=layers,PanoHeight=pano_height,Pos=0;
	var over_last,down_last,link_last;
	var state=false;
	var canvas = document.createElement('canvas');
	canvas.width=width;
	canvas.height=height;
	canvas.id="id_canvas_"+Path;
	var context=canvas.getContext("2d");
	var X=0,Y=0;
	var Img=new Array(Layers);
	for (i=0;i<Layers;i++) { Img[i]=new Image(); Img[i].src=path+"/img_"+(1*i+1)+imgtype; }
	
	canvas.onmousemove=function(e) { X=e.offsetX; Y=e.offsetY; };
	canvas.onmousedown=function(e) { state=true; };
	canvas.onmouseup=function(e) { state=false;	};
	canvas.onmouseover=function(e) { state=false; };
	canvas.onmouseout=function(e) { state=false; };

	canvas.addEventListener('touchmove', function(event) { 
		event.preventDefault();
		if (!state) return;
		var touch = event.changedTouches[0]; 
		X=touch.pageX-canvas.offsetLeft; Y=touch.pageY-canvas.offsetTop; 
	}, false);

	canvas.addEventListener('touchstart', function(event) {
		event.preventDefault(); 		
		var touch = event.changedTouches[0];
		X=touch.pageX-canvas.offsetLeft; Y=touch.pageY-canvas.offsetTop; 
		state=true;
	}, false);

	canvas.addEventListener('touchend', function(event) { event.preventDefault(); state=false; }, false);

	canvas.addEventListener('touchcancel', function(event) { state=false; }, false);

	canvas.check=function() {
		var x,y,dx,sm=0,area,n,m,k;
		var rect=canvas.getBoundingClientRect();
		var index=0;
		area=Math.floor(7*Y/rect.height);
		dy=rect.height/7;
		if (area==3) sm=0; 
		else if (area==0) sm=-Math.round((dy-Y)*2+1.5*dy);
		else if (area==1) sm=-Math.round((2*dy-Y)+0.5*dy);
		else if (area==2) sm=-Math.round((3*dy-Y)/2);
		else if (area==4) sm=Math.round((Y-4*dy)/2);
		else if (area==5) sm=Math.round((Y-5*dy)+0.5*dy);
		else if (area==6) sm=Math.round((Y-6*dy)*2+1.5*dy);
		sm=Math.round(sm/5);
		if (!state) sm=0; 
		n=Math.floor(Layers*X/rect.width);
		Pos=1*Pos+1*sm;
		if (1*Pos+1*rect.height>=1*PanoHeight) Pos=PanoHeight-rect.height;
		if (1*Pos<0) Pos=0;
		if (Img[n].complete) context.drawImage(Img[n],0,-Pos); 
	};
	
	document.writeln("<div id='id_div_"+Path+"'></div>");
	document.getElementById("id_div_"+Path).insertBefore(canvas,null);
	setInterval('document.getElementById("id_canvas_'+Path+'").check()',30);

}
